#   Version 6.0.3

########## ########## ########## ########## ########## ########## ########## ########## #########
# This .conf file is DEPRECATED as of Splunk 6.0; support for it and the feature it configures, #
# Multi-Tenanted Deployment Server, will be removed altogether in the next major release.       #
########## ########## ########## ########## ########## ########## ########## ########## #########

#
# Use tenants.conf to redirect incoming requests from deployment clients to another deployment 
# server or servers. This is typically used for offloading load on your splunkd's HTTP server. 
# This is not a typical configuration for deployment server. There is no default tenants.conf
#
# There is no need to create/edit tenants.conf* unless you have worked with Splunk Professional 
# Services to design a custom deployment that includes explicit involvement of tenants.conf. 
#
# To set custom configurations, place a pubsub.conf in $SPLUNK_HOME/etc/system/local/. 
# For examples, see pubsub.conf.example. You must restart Splunk to enable configurations.
#
# To learn more about configuration files (including precedence) please see the documentation 
# located at http://docs.splunk.com/Documentation/Splunk/latest/Admin/Aboutconfigurationfiles

# GLOBAL SETTINGS
# Use the [default] stanza to define any global settings.
#     * You can also define global settings outside of any stanza, at the top of the file.
#     * Each conf file should have at most one default stanza. If there are multiple default
#       stanzas, attributes are combined. In the case of multiple definitions of the same
#       attribute, the last definition in the file wins.
#     * If an attribute is defined at both the global level and in a specific stanza, the
#       value in the specific stanza takes precedence.

#***************************************************************************
# Configure tenants (DeploymentServer instances) within the same Splunk server.
# 
# Multiple instances of deployment servers can be configured within the same Splunk instance 
# using this configuration file.
# If this file is missing, a default DeploymentServer for tenant='default'is configured 
# by the system, if there exists serverclass.conf or default-serverclass.conf.

############# It is possible to redirect deployment clients to the appropriate instance of deployment server? ##############
# by using a whitelist/blacklist mechanism, similar to the one in serverclass.conf.

######## How does it all work? ############
# A DeploymentClient does a handshake with TenantService to determine which DeploymentServer
# it should be talking to. The TenantService will use this configuration to redirect a 
# client to the appropriate deployment server (represented by phoneHomeTopic).

######## How is multi-tenant configuration stored? #########
# Server class configuration for each tenant (except for 'default' tenant) MUST be made available in:
# <tenantName>-serverclass.conf, and MUST include at least 1 serverclass.
#
# Server class configuration for the 'default' tenant MAY be made available in:
# <tenantName>-serverclass.conf; it MAY also reside in 'serverclass.conf' (note the missing
# <tenantName> prefix) in this case.  The 'default' tenant MAY be associated with 0 serverclasses.

[tenant:<tenantName>]

filterType = whitelist|blacklist
    * defaults to whitelist

whitelist.<n> = <IP address or hostname or clientName>
blacklist.<n> = <IP address of hostname of clientName>

    * 'n' is a number starting at 0, and increasing by 1. Stop looking at the filter when 'n' breaks.
    * IP address of deployment client.  Can also use wildcards, such as 10.1.1.*
    * hostname of deployment client.  Can also use wildcards as *.splunk.com.
    * clientName- a logical or 'tag' name that can be assigned to each deployment client in deploymentclient.conf.  Takes precedence (over IP/hostname) when matching a client to a filter.

# Internal.
phoneHomeTopic=deploymentServer/phoneHome/$tenantName$
    * some unique suffix. Default is to use the tenant name. Make sure this value is unique.
    * Override this value only when you wish to script and roll your own deployment server.

token = <token-id for phone home communication>
	* defaults to 'default' 

########## ########## ########## ########## ########## ########## ########## ########## #########
# This .conf file is DEPRECATED as of Splunk 6.0; support for it and the feature it configures, #
# Multi-Tenanted Deployment Server, will be removed altogether in the next major release.       #
########## ########## ########## ########## ########## ########## ########## ########## #########
