from datamodel.base import Base
from datamodel.baseEvent import BaseEvent
from datamodel.field import Field
from datamodel.calculation import Eval

DEBUG=False

class BaseInterface(Base):
    def __init__(self):
	Base.__init__(self)
	self.name = 'BaseInterface'
        #self.fields = [Field("_time",owner=self.name, required=True)] 
        self.prependSearch = '' 
	self.parentname=self.__class__.__bases__[0].__name__ 
	self.objectType='BaseInterface'
	self.implementsObjects = []

	if DEBUG:
	    print "in BaseInterface constructor"

    def getImplementsNames(self):
	if DEBUG:
	    print "in getImplementsNames"
	implements = []
	for i in self.implementsObjects:
	  implements.append(i.getName())
	return implements

    def addImplementsObject(self, implements):
	self.implementsObjects.append(implements)

    def getImplementsObjects(self):
	return self.implementsObjects

    def setImplementsObjects(self, implObjs):
	self.implementsObjects = implObjs


    def search(self, mode='full'):
	# get list of objects that implement this interface
	# multisearch [concreteobj1.search() | mappingsearch][concreteobj2.search() | mappingsearch ] 
	# provides the filter stuff plus converters that translate data to existing interface		

	retval = ''

        if self.tstatsNamespace == '':
	  retval+=self.prependSearch

	  if len(self.getImplementsObjects())>1:
  	    #using multisearch command to parallelize search in the case of multiple implements classes
  	    count=0	
	    #FIXME: somewhere here we need to allow filtering some of the implements classes,
	    #i.e. if it's in the "filter out" list don't add it here
  	    for classname in self.getImplementsObjects():
  	      if count==0:
  		retval = retval + "| multisearch "
  	      retval += "[" + classname.search(mode="preview") + "]"
    	      count=count+1
	  elif len(self.getImplementsObjects())==1:
	    #just regular search if only one implementing class
	    classname = self.getImplementsObjects()[0]
  	    retval += classname.search(mode="preview") 

	basesearch=Base.search(self,mode)
	if basesearch!='' and not basesearch.startswith("|") and not basesearch.startswith(" |"):
	  retval +=  ' | search ' 
	retval += basesearch
        return retval 
      

    def JSONdesc(self, conciseMode):
	desc = Base.JSONdesc(self, conciseMode)
 	desc["implementedBy"] = self.getImplementsNames()
	return desc



class BaseImplements(BaseEvent):
    def __init__(self, interfaceobject):
	BaseEvent.__init__(self)
        self.name = 'BaseImplements'
        self.objectType = 'BaseImplements'
	self.implementsinterface =  interfaceobject
	self.interfacemappings = []
	self.needmapping = []
	self.parentname=self.__class__.__bases__[0].__name__ 
	self.prependSearch = ''
	self.childObjects =  self.implementsinterface.getChildObjects()
	#these should have their own set of required fields
	for field in self.implementsinterface.getFields():
	    # provide mapping to interface's required field
	    if field not in self.fields:
		self.needmapping.append(field) # keeping a list of Fields rather than just fieldnames so we can have constraints too

    def getNeedMappingList(self):
	return self.needmapping

    def setMapping(self, fieldname, value):	
	# FIXME: need to check if needmapping has the fieldname. if not, it's an "extend" of sorts that we don't know what to do with
	for field in self.needmapping:
	    if field.getName() == fieldname:
	  	self.evalField(self.getName(), field.JSONdesc(), value) # treat it as a regular calculation
	    	self.needmapping.remove(field)

    def setMappingList(self, fieldnamevaluelist):
	for item in fieldnamevaluelist:
	    self.setMapping(item['fieldname'],item['fieldvalue'])
   
    def getInterfaceName(self):
	return self.implementsinterface.getName()

    def JSONdesc(self, conciseMode):
	desc = {}
	desc = BaseEvent.JSONdesc(self, conciseMode)
	desc['implementsInterface'] = self.getInterfaceName()	
        return desc

