import glob
import logging, logging.handlers
import math
import os
import sys
import tempfile
import time
import string

import splunk
import splunk.auth as auth
import splunk.search as search
import splunk.util as util

SPLUNK_HOME = os.environ['SPLUNK_HOME']

class SplunkSearch:
    
    def __init__(self, objectSearch, earliest, latest, seedSearch="", eval=None):
	self.earliest = earliest
	self.latest = latest
	self.eval = eval
	self.objectSearch = objectSearch
	self.seedSearch = seedSearch

    def getSearch(self):
        searchtext = "search earliest=" + self.earliest + " latest=" + self.latest + " " 
        searchtext = searchtext + self.seedSearch
        if type(self.objectSearch) == str:
	    if self.objectSearch != '*':
                searchtext = searchtext + self.objectSearch
	if type(self.eval) == str:
	    searchtext = searchtext + " | " + self.eval
	#if type(self.stats) == str:
	#    searchtext = searchtext + " | " + self.stats
	self.searchtext = searchtext
	return self.searchtext 
       
    def dispatchSearch(self):
	self.searchtext = self.searchtext + ' | table *'
	self.job = search.dispatch(self.searchtext)
 
    def printJob(self, jobname):
        while self.job.isDone==False:
            print "searching"
            time.sleep(5)
        print '***************BEGIN: ', jobname, '****************'
        print ' count is: \n', self.job.count
        print ' 0th event is: \n', self.job.events[0]
        print ' dispatch details are: \n', self.job
        print '***************END: ', jobname, '******************'
   
    def getJob(self):
	return self.job 

    def getResults(self):
	return self.job.results
 
