define(function(require, exports, module) {
    var _ = require('underscore');
    
    var mount = "dj";
    var urlpatterns = {"home": [{"kwargs": {}, "pattern": "/", "app": ""}, {"kwargs": {}, "pattern": "/araitz/home/", "app": "araitz"}, {"kwargs": {}, "pattern": "/drilldownfx/home/", "app": "drilldownfx"}, {"kwargs": {}, "pattern": "/formlab/", "app": "formlab"}, {"kwargs": {}, "pattern": "/homefx/", "app": "homefx"}, {"kwargs": {}, "pattern": "/lunch1/home/", "app": "lunch1"}, {"kwargs": {}, "pattern": "/searchfx/", "app": "searchfx"}, {"kwargs": {}, "pattern": "/simplexml/", "app": "simplexml"}, {"kwargs": {}, "pattern": "/singlefileapp/", "app": "singlefileapp"}, {"kwargs": {}, "pattern": "/splunkdev/", "app": "splunkdev"}, {"kwargs": {}, "pattern": "/splunkmix/", "app": "splunkmix"}, {"kwargs": {}, "pattern": "/testfx/home/", "app": "testfx"}, {"kwargs": {}, "pattern": "/testsite/", "app": "testsite"}, {"kwargs": {}, "pattern": "/vizfx/", "app": "vizfx"}, {"kwargs": {}, "pattern": "/webfx/home/", "app": "webfx"}, {"kwargs": {}, "pattern": "/xkcd/home/", "app": "xkcd"}], "login": [{"kwargs": {}, "pattern": "/accounts/login/", "app": ""}], "logout": [{"kwargs": {}, "pattern": "/accounts/logout/", "app": ""}, {"kwargs": {}, "pattern": "/formlab/logout", "app": "formlab"}, {"kwargs": {}, "pattern": "/homefx/logout/", "app": "homefx"}, {"kwargs": {}, "pattern": "/simplexml/logout", "app": "simplexml"}, {"kwargs": {}, "pattern": "/splunkdev/logout", "app": "splunkdev"}, {"kwargs": {}, "pattern": "/webfx/logout/", "app": "webfx"}], "job_history": [{"kwargs": {}, "pattern": "/araitz/job_history/", "app": "araitz"}], "target": [{"kwargs": {}, "pattern": "/drilldownfx/target/", "app": "drilldownfx"}], "root": [{"kwargs": {}, "pattern": "/formlab/", "app": "formlab"}, {"kwargs": {}, "pattern": "/simplexml/", "app": "simplexml"}, {"kwargs": {}, "pattern": "/splunkdev/", "app": "splunkdev"}, {"kwargs": {}, "pattern": "/webfx/", "app": "webfx"}], "page": [{"kwargs": {}, "pattern": "/formlab/<page>/", "app": "formlab"}, {"kwargs": {}, "pattern": "/simplexml/<page>/", "app": "simplexml"}, {"kwargs": {}, "pattern": "/splunkdev/<page>/", "app": "splunkdev"}], "panels": [{"kwargs": {}, "pattern": "/lunch1/panels/", "app": "lunch1"}], "interactive": [{"kwargs": {}, "pattern": "/lunch1/interactive/", "app": "lunch1"}], "simplexml": [{"kwargs": {}, "pattern": "/lunch1/simplexml/", "app": "lunch1"}], "search": [{"kwargs": {}, "pattern": "/searchfx/search/", "app": "searchfx"}, {"kwargs": {}, "pattern": "/singlefileapp/", "app": "singlefileapp"}, {"kwargs": {}, "pattern": "/webfx/search/", "app": "webfx"}], "viewdata": [{"kwargs": {}, "pattern": "/simplexml/viewdata/apps/<app>/<path>", "app": "simplexml"}, {"kwargs": {}, "pattern": "/simplexml/viewdata/<path>", "app": "simplexml"}], "compiled_dashboard": [{"kwargs": {}, "pattern": "/simplexml/compiled/dashboard/", "app": "simplexml"}], "compiled_dashboard_drilldown": [{"kwargs": {}, "pattern": "/simplexml/compiled/dashboard/drilldown/", "app": "simplexml"}], "compiled_dashboard_interactive": [{"kwargs": {}, "pattern": "/simplexml/compiled/dashboard/interactive/", "app": "simplexml"}], "compiled_form": [{"kwargs": {}, "pattern": "/simplexml/compiled/form/", "app": "simplexml"}], "compiled_formplus": [{"kwargs": {}, "pattern": "/simplexml/compiled/formplus/", "app": "simplexml"}], "apps": [{"kwargs": {}, "pattern": "/splunkdev/apps/", "app": "splunkdev"}], "indexes": [{"kwargs": {}, "pattern": "/splunkdev/indexes/", "app": "splunkdev"}], "searches": [{"kwargs": {}, "pattern": "/splunkdev/searches/", "app": "splunkdev"}], "overview": [{"kwargs": {}, "pattern": "/splunkmix/overview/", "app": "splunkmix"}], "activity": [{"kwargs": {}, "pattern": "/webfx/activity/", "app": "webfx"}], "service": [{"kwargs": {}, "pattern": "/webfx/service/", "app": "webfx"}], "sources": [{"kwargs": {}, "pattern": "/webfx/sources/", "app": "webfx"}], "users": [{"kwargs": {}, "pattern": "/webfx/users/", "app": "webfx"}]};
    
    var reverse = function(name, app, args) {
        if (!args && _.isObject(app)) {
            args = app;
            app = '';
        }
        
        if (!name) {
            throw new Error("Must provide a name for path reverse.");
        }
      
        if (name.indexOf(":") > -1 && !app) {
            var parts = name.split(":");
            name = parts[1];
            app = parts[0];  
        }
        
        if (!name) {
            throw new Error("Must provide a name for path reverse.");
        }
        
        if (!urlpatterns.hasOwnProperty(name)) {
            throw new Error("No URL path with name '" + name + "' exists.");
        }
        
        var pattern = null;
        var patterns = urlpatterns[name];
        
        // If there is only one pattern and the user
        // didn't specify an app, return the first one
        if (patterns.length === 1 && !app) {
            pattern = patterns[0];
        }
        else {
            for(var i = 0; i < patterns.length; i++) {
                if (patterns[i].app === app) {
                    pattern = patterns[i];
                }
            }
        }
        
        if (!pattern) {
            throw new Error("No URL path with name '" + name + "' in app '" + app + "' exists.");
        }
        
        var path = "/" + mount + pattern.pattern;
        args = _.extend(_.clone(pattern.kwargs), args);
        _.each(args, function(value, key) {
            if (!path.match("<" + key + ">")) {
                throw new Error("Key '" + key + "' does not exist in path: '" + path + "'");
            }
            
            path = path.replace("<" + key + ">", value);
        });
        
        var re = new RegExp("<[a-zA-Z0-9-_]{1,}>", "g");
        var missingArgs = path.match(re);
        if (missingArgs) {
            throw("Missing arguments (" + missingArgs.join(", ") + ") for path '" + path + "'");
        }
        
        return path;
    };
    
    return {
        reverse: reverse
    };
});