define(function(require, exports, module) {    
    var $ = require("jquery");
    
    var ready = function(callback, req) {
        req = req || require;
        
        // Load our base dependencies
        var deps = ["splunkjs/mvc", "underscore"];
        
        // Find all the components that were existent as DOM elements,
        // and add their dependencies, but only for ones that haven't
        // been initialized yet
        $("[data-require]:not([data-initialized])").each(function() {
            var $this = $(this);
            deps.push($this.attr("data-require"));
        });
        
        req(deps, function(mvc) {
            // Load all pre-existing components, and we know we required
            // them
            splunkjs.mvc._loadDOMComponents();
            
            // Initiate the callback
            callback(mvc);
        });
    };
    
    ready.load = function(name, req, onLoad, config) {
        if (config.isBuild) {
            onLoad(null);
        }
        else {
            ready(onLoad, req);
        }
    };
    
    return ready;
});