define(
    [
        'underscore',   
        'models/services/configs/EventRenderer',
        'collections/SplunkDsBase'
    ],
    function(_, EventRendererModel, SplunkDsBaseCollection) {
        return SplunkDsBaseCollection.extend({
            url: "configs/conf-event_renderers",
            model: EventRendererModel,
            initialize: function() {
                SplunkDsBaseCollection.prototype.initialize.apply(this, arguments);
            },
            getRenderer: function(eventtype) {
                if(!eventtype) return;
                if(eventtype.length==1){
                    return this._matchEventType(eventtype[0]);
                } else {
                    var priorities = {};
                    _(eventtype).each(function(v, i) {
                        var renderer = this._matchEventType(v);
                        if(renderer) 
                            priorities[parseInt(renderer.entry.content.get('priority'), 10)] = renderer;    
                    },this);
                    if(!priorities) return;
                    return priorities[_.chain(priorities).keys().map(function(v) { return parseInt(v, 10); }).max().value()];
                }
            },
            _matchEventType: function(eventtype) {
                for(var i=0; i<this.models.length; i++){
                    var renderer = this.models[i];
                    if(renderer.entry.content.get('eventtype')===eventtype){
                        return renderer;
                    }
                }
            }
        });
    }
);
