define(['jquery', './ManyShapeSeries', '../util/lang_utils'], function($, ManyShapeSeries, langUtils) {

    var ScatterSeries = function(properties) {
        ManyShapeSeries.call(this, properties);
    };
    langUtils.inherit(ScatterSeries, ManyShapeSeries);

    $.extend(ScatterSeries.prototype, {

        type: 'scatter',

        getLeftColData: function(info) {
            return [info.labelSeriesName, info.xAxisName, info.yAxisName];
        },

        getRightColData: function(info) {
            return [info.seriesName, info.xValue, info.yValue];
        },

        tooltipTemplate: '\
            <table class="highcharts-tooltip"\
                <% if(willWrap) { %>\
                    style="word-wrap: break-word; white-space: normal;"\
                <% } %>>\
                <% if(isMultiSeries) { %>\
                    <tr>\
                        <td style="text-align: left; color: #cccccc; max-width: <%= scaledMaxLeftColWidth %>;"><%- labelSeriesName %>:&nbsp;&nbsp;</td>\
                        <td style="text-align: right; color: <%= seriesColor %>; max-width: <%= scaledMaxRightColWidth %>;"><%- seriesName %></td>\
                    </tr>\
                <% } %>\
                <% if(markName) { %>\
                    <tr>\
                        <td style="text-align: left; color: #cccccc; max-width: <%= scaledMaxLeftColWidth %>;"><%- markName %>:&nbsp;&nbsp;</td>\
                        <td style="text-align: right; color: #ffffff; max-width: <%= scaledMaxRightColWidth %>;"><%- markValue %></td>\
                    </tr>\
                <% } %>\
                <tr>\
                    <td style="text-align: left; color: #cccccc; max-width: <%= scaledMaxLeftColWidth %>;"><%- xAxisName %>:&nbsp;&nbsp;</td>\
                    <td style="text-align: right; color: #ffffff; max-width: <%= scaledMaxRightColWidth %>;"><%- xValue %></td>\
                </tr>\
                <tr>\
                    <td style="text-align: left; color: #cccccc; max-width: <%= scaledMaxLeftColWidth %>;"><%- yAxisName %>:&nbsp;&nbsp;</td>\
                    <td style="text-align: right; color: #ffffff; max-width: <%= scaledMaxRightColWidth %>;"><%- yValue %></td>\
                </tr>\
            </table>\
        '

    });

    return ScatterSeries;

});