/**
 * @author jszeto
 * @date 1/4/13
 *
 * Working model to create a new data model
 */
define([
    'models/Base'
],
    function(
        BaseModel
        ) {

        return BaseModel.extend({

            idAttribute: 'displayName',
            defaults: {displayName:"",
                       description:"",
                       modelName:"",
                       app:""},

            validation: {
                displayName : {
                    required : true,
                    msg: "Title is required"
                },
                modelName: [
                    {
                        required: true,
                        msg: "ID is required"
                    },
                    {
                        pattern: /^[\w\-]+$/,
                        msg: "ID can only contain alphanumeric characters, underscores or hyphens. Whitespace is not allowed."
                    }
                ]
            }
        });
    });