/**
 * @author jszeto
 * @date 12/7/12
 */
define(['underscore',
        'backbone',
        'models/services/datamodel/private/Calculation',
        'collections/services/datamodel/private/LookupOutputFields'
       ],
    function(
        _,
        Backbone,
        Calculation,
        LookupOutputFields
    ) {

    /**
     * Represents a Lookup Calculation.
     *
     */
    return Calculation.extend({

        defaults: {
            calculationType: "Lookup",
            lookupName: "",
            inputField: "",
            lookupField: "",
            editable: true
        },

        validation: {
            lookupName : {
                required : true,
                msg: _("Select a valid Lookup Table.").t()
            },
            lookupField: {
                required : true,
                msg: _("Input Field in Lookup is a required field").t()
            },
            inputField : {
                required : true,
                msg: _("Select a valid Input Attribute.").t()
            }
        },

        initializeAssociated: function() {
            this.associated = this.associated || {};
            this.outputFields = this.associated.outputFields = this.outputFields || new LookupOutputFields();
            this.outputFields.on("change associatedChange add remove update reset",
                function(model, options) {
                    this.trigger("associatedChange", model, options);
                }, this);
        }
    });
});