/**
 * @author jszeto
 * @date 12/7/12
 */
define(['underscore', 'backbone', 'models/services/datamodel/private/Calculation'], function(_, Backbone, Calculation) {

    /**
     * Represents a Rex Calculation.
     *
     */
    return Calculation.extend({

        defaults: {
            calculationType: "Rex",
            expression: "",
            inputField: "",
            outputFields: undefined,
            editable: true
        },

        validation: {
            expression : [
                {
                    required : true,
                    msg: _("Regular Expression is a required field.").t()
                }/*,
                {
                    fn : function(value, attr, computedState) {
                        var outputFields = computedState.outputFields;
                        if (outputFields instanceof Backbone.Collection) {
                            if (outputFields.length == 0) {
                                return "A Rex Calculation must contain at least one outputField";
                            }
                        } else {
                            return "Rex Calculation outputFields is invalid";
                        }
                    }
                }*/
            ],
            inputField : {
                required : true,
                msg : _("Select a field to Extract From.").t()
            },
            calculationType : {
                oneOf : ["Rex"]
            }

        }

    });
});