define([
            'jquery',
            'underscore',
            'models/SplunkDRaw',
            'models/fetch_data/ResultsFetchData'
        ],
        function(
            $,
            _,
            SplunkDRaw,
            ResultsFetchData
        ) {

    return SplunkDRaw.extend({

        initialize: function(attributes, options) {
            options = options || {};
            options.fetchData = new ResultsFetchData({ output_mode: 'json_cols', show_metadata: true });
            this.lastFetchParams = {};
            SplunkDRaw.prototype.initialize.call(this, attributes, options);
        },

        parse: function(response, options) {
            options = options || {};
            // store a copy of the fetch params for introspection later
            this.lastFetchParams = $.extend(true, {}, options.data);
            return _(response).pick('fields', 'columns');
        },

        // return the 'count' parameter that was used to fetch the most recent data set,
        // or 100 if it wasn't specified (the endpoint default)
        getFetchCount: function() {
            return this.lastFetchParams.hasOwnProperty('count') ? this.lastFetchParams.count : 100;
        }

    });

});