define(
    [
        'jquery',
        'underscore',
        'collections/services/datamodel/DataModels',
        'models/services/datamodel/DataModel',
        'models/classicurl',
        'views/data_model_explorer/DataModelExplorer',
        'splunk.util',
        'routers/Base'
    ],
    function(
        $,
        _,
        DataModelCollection,
        DataModel,
        classicUrl,
        DataModelExplorer,
        splunkUtils,
        BaseRouter
    ) {
        return BaseRouter.extend({

            initialize: function() {
                BaseRouter.prototype.initialize.apply(this, arguments);
                this.setPageTitle(_('Select an Object').t());

                this.dataModels = new DataModelCollection();
                this.dataModel = new DataModel();

                this.dmExplorerView = new DataModelExplorer({
                    model: {
                        dataModel: this.dataModel,
                        application: this.model.application
                    },
                    collection: {
                        dataModels: this.dataModels
                    }
                });
            },

            page: function(localeValue, appValue, pageValue) {
                BaseRouter.prototype.page.apply(this, arguments);
                if (this.shouldRender) {
                    $('.preload').replaceWith(this.pageView.el);
                    this.pageView.$('.main-section-body').append($('<div class="dm-explorer-placeholder"></div>'));
                } 
                var that = this;
                classicUrl.fetch().done(function() {
                    if(!classicUrl.get('model')) {
                        splunkUtils.redirect_to('app/' + that.model.application.get('app') + '/data_models');
                    }
                    that.dataModel.set({ id: classicUrl.get('model') });

                    var appOwner = { app: that.model.application.get('app'), owner: that.model.application.get('owner') };
                    that.dataModels.fetch({ data: $.extend({ concise: true }, appOwner) }).done(function() {
                        $('.dm-explorer-placeholder').replaceWith(that.dmExplorerView.render().el);
                    });

                    that.dataModel.fetch({ data: appOwner });
                });
            }
        });
    }
);
