define(
    [
        'jquery',
        'underscore',
        'routers/Base',
        'backbone', 
        'views/deploymentserver/edit/app/EditApp',
        'collections/services/DeploymentServerClasses',
        'collections/services/DeploymentServerClients',
        'models/services/DeploymentApplication',
        'models/classicurl',
        'bootstrap.tab'
    ],
    function(
        $,
        _,
        BaseRouter,
        Backbone, 
        EditAppView,
        DeploymentServerClassesCollection, 
        DeploymentClientsCollection, 
        DeploymentAppModel,
        classicurlModel,
        undefined
    ){
        return BaseRouter.extend({
            initialize: function() {
                BaseRouter.prototype.initialize.apply(this, arguments);
                this.setPageTitle(_('Edit App').t());
                this.enableAppBar = false;
            },
            page: function(locale, app, page) {
                BaseRouter.prototype.page.apply(this, arguments);
                $('.preload').replaceWith(this.pageView.el);

                //collections
                var selectedClients =  new DeploymentClientsCollection();  
                var filteredClients =  new DeploymentClientsCollection();  
                var serverClasses =  new DeploymentServerClassesCollection();  
                var selectedServerClasses =  new Backbone.Collection(); 
                var previousSelectedServerClasses =  new Backbone.Collection(); 
                serverClasses.fetch({data:{count: -1, offset: 0}}); 

                var that = this; 
                classicurlModel.fetch({
                    success: function() {
                        var appModel = new DeploymentAppModel(); 
                        appModel.set("id", classicurlModel.get('id')); 
                        that.editAppView = new EditAppView({
                            model: {
                               app:  appModel
                            },
                            collection: { 
                                selectedClients: selectedClients,  
                                filteredClients: filteredClients,  
                                serverClasses: serverClasses,  
                                selectedServerClasses: selectedServerClasses,  
                                previousSelectedServerClasses: previousSelectedServerClasses
                            },
                            application: that.model.application 
                        });  

                    }
                });

                this.pageView.$('.main-section-body').append(this.editAppView.render().el);
            }
        });
    });
