define(function(require, exports, module) {    
    var utils = require("util/splunkd_utils");
    var config = require("JS_CACHE/config");
    
    // The original fullpath method.
    var fullpath = utils.fullpath;
    
    // The original splunkd_utils.fullpath() method is hard coded to use
    // the Splunkweb "/{locale}/splunkd/__raw" endpoint. This is problematic
    // when we are not running in the context of Splunkweb. As such, we 
    // intercept the call, and replace any use of the above with the actual
    // PROXY_PATH, which we have as our configuration.
    utils.fullpath = function() {
        // Resolve the path using the original function.
        var resolvedPath = fullpath.apply(utils, arguments);
        
        // Calculate where the __raw ends and find the remainder.
        var pathIndex = resolvedPath.indexOf("__raw") + 5;
        var apiPath = resolvedPath.substr(pathIndex);
        
        // The new path is simply the proxy path prefixed to the API path.
        return config.PROXY_PATH + apiPath;
    };
    
    return utils; 
});