define(function(require, module){
    var _ = require('underscore'),
        $ = require('jquery'),
        BaseView = require('views/Base'),
        Dashboard = require('../simplexml/controller');

    return BaseView.extend({
        moduleId: module.id,
        className: 'fieldset',
        initialize: function() {
            Dashboard.on('formupdate', this.render, this);
            BaseView.prototype.initialize.apply(this, arguments);
        },
        render: function() {
            if(_.any(this.$el.find('label'), function(label) {
                var txt = $(label).text();
                return !!$.trim(txt);
            })) {
                this.$el.removeClass('hide-label');
            } else {
                this.$el.addClass('hide-label');
            }
            return this;
        }
    });
});