define(function(require) {
    var _ = require('underscore');
    var $ = require('jquery');
    var BaseInput = require('./base');
    var SelectView = require('../../dropdownview');

    var DropdownInput = BaseInput.extend({
        initialize: function() {
            var inputOptions = _.defaults({
                el: $('<div class="splunk-view"></div>').appendTo(this.el),
                id: _.uniqueId(this.id + '-input')
            }, this.options);
            this.select = new SelectView(inputOptions);
            this.select.on('change', this.handleChange, this);
            
            // Always use the inner view's settings, so we don't have two of them
            this.options.settings = this.select.settings;
            BaseInput.prototype.initialize.call(this, {inputId: inputOptions.id});
        },
        getValue: function() {
            return this.select.val();
        },
        setValue: function(v) {
            this.select.val(v);
        },
        render: function() {
            this.renderLabel();
            this.select.render();
            return this;
        },
        _getWrappedView: function() {
            return this.select;
        }
    });
    
    return DropdownInput;
});
