define(function(require) {
    var _ = require('underscore'),
            $ = require('jquery'),
            BaseInput = require('./base'),
            RadioGroupView = require('../../radiogroupview');

    var RadioGroupInput = BaseInput.extend({
        events: {
            'change input': 'handleChange'
        },
        initialize: function() {
            var inputOptions = _.defaults({
                el: $('<div class="splunk-view"></div>').appendTo(this.el),
                id: _.uniqueId(this.id + '-input')
            }, this.options);
            this.radiogroup = new RadioGroupView(inputOptions);
            
            // Always use the inner view's settings, so we don't have two of them
            this.options.settings = this.radiogroup.settings;
            BaseInput.prototype.initialize.call(this, {inputId: inputOptions.id});
        },
        getValue: function() {
            return this.radiogroup.val();
        },
        setValue: function(v) {
            this.radiogroup.settings.set('default', v);
            this.radiogroup.val(v);
        },
        render: function() {
            this.renderLabel();
            this.radiogroup.render();
            return this;
        },
        _getWrappedView: function() {
            return this.radiogroup;
        }
    });
    
    return RadioGroupInput;
});
