define(function(require) {
    var _ = require('underscore'),
            $ = require('jquery'),
            BaseSplunkView = require('../../basesplunkview'),
            mvc = require('../../mvc');

    var SubmitButton = BaseSplunkView.extend({
        className: 'splunk-submit-button',
        options: {
            text: _('Search').t(),
            useIcon: false,
            submitType: undefined
        },
        events: {
            'click button': 'onButtonClick'
        },
        initialize: function() {
            this.configure();
            this.settings.on('change', this.render, this);
        },
        onButtonClick: function() {            
            // Notify listeners
            this.trigger("submit", this);
        },
        render: function() {
            var button = this.$('button');
            if(!button.length) {
                button = $('<button class="btn btn-primary"></button>').appendTo(this.el);
            }
            if(this.settings.get('useIcon')) {
                button.html('<i class="icon-search"></i>');
            } else if(this.settings.has('text')) {
                button.text(this.settings.get('text'));
            } else {
                this.settings.set('text', button.text());
            }
            return this;
        }
    });
    
    return SubmitButton;
});