define(function(require) {
    var $ = require('jquery'),
        Backbone = require('backbone');

    /**
     * Delegate view for dashboard panels that deals with hiding/showing the drag-handle for edit mode
     */
    return Backbone.View.extend({
        initialize: function() {
            this.listenTo(this.model, 'change:edit', this.onEditStateChange, this);
        },
        onEditStateChange: function(model) {

            if(model.get('edit')) {
                if(!this._dragHandle) {
                    this._dragHandle = $('<div class="drag-handle"><div class="handle-inner"></div></div>');
                }
                this._dragHandle.prependTo(this.el);
            } else {
                if(this._dragHandle) {
                    this._dragHandle.detach();
                }
            }
        },
        render: function() {
            this.onEditStateChange(this.model);
            return this;
        }
    });

});