define([
            'jquery',
            'underscore',
            'splunk.logger'
        ],
        function(
            $,
            _,
            SplunkLogger
        ) {

    var logger = SplunkLogger.getLogger('ajax_logging.js');

    // black-list of AJAX URLs that should not be logged
    var URL_BLACKLIST = [
        SplunkLogger.mode.Server.END_POINT,
        'services/messages'
    ];

    $.ajaxPrefilter(function(options, originalOptions, jqXHR) {
        var passesBlacklist = _(URL_BLACKLIST).every(function(blacklistUrl) {
            return options.url.indexOf(blacklistUrl) === -1;
        });
        if(passesBlacklist) {
            logger.debug('sending AJAX request to ', options.url);
            logger.trace();
        }
    });

});