define([
    'jquery',
    'module',
    'views/Base',
    'contrib/text!views/clustering/peer/PeerDetails.html',
    'bootstrap.tooltip'
],
    function(
        $,
        module,
        BaseView,
        PeerDetailsTemplate,
        bsToolTip
        ) {
        return BaseView.extend({
            moduleId: module.id,
            tagName: 'dl',
            className: 'list-dotted',
            template: PeerDetailsTemplate,
            initialize: function(options) {
                var self = this;
                BaseView.prototype.initialize.call(this, options);
                this.model.peerStatus.on('change reset', function(){
                    self.render.call(this);
                });
                this.model.clusterConfig.entry.content.on('change reset', function(){
                    self.render.call(this);
                });
            },
            render: function() {
                var html = this.compiledTemplate(this.model);
                this.$el.html(html);
                this.$('.tooltip-link').tooltip({animation:false, container: 'body'});
                return this;
            }
        });
    });
