define([
    'jquery',
    'underscore',
    'module',
    'views/Base',
    'contrib/text!views/home/FindAndManageApps.html',
    'splunk.util',
    'uri/route'
],
function(
    $,
    _,
    module,
    BaseView,
    findAndManageAppsTemplate,
    splunk_util,
    route
){
    return BaseView.extend({
        moduleId: module.id,
        initialize: function(){
            BaseView.prototype.initialize.call(this, arguments);
            this.viewTemplate = _.template(findAndManageAppsTemplate);

            var appDfd = $.Deferred();
            this.model.application.on('change', function(){
                this.render();
                appDfd.resolve();
            }.bind(this));

            $.when(
                this.options.canManageRemoteAppsDfd,
                appDfd
            ).done(function(){
                this.showFindMoreApps();
            }.bind(this));
        },
        render: function(){
            this.$el.html(this.viewTemplate({
                makeManagerLink: this.makeManagerLink.bind(this)
            }));
            return this;
        },
        makeManagerLink: function(managerPage){
            return route.manager(
                this.model.application.get('root'),
                this.model.application.get('locale'),
                this.model.application.get('app'),
                managerPage
            );
        },
        showFindMoreApps: function(){
           this.$('#findMoreAppsBtn').show();
        }
    });
});
