define(
    [
        'underscore',
        'module',
        'views/Base',
        'splunk.i18n'
    ],
    function(_, module, Base, i18n) {
        return Base.extend({
            moduleId: module.id,
            tagName: 'span',
            className: 'pull-left',
            initialize: function() {
                Base.prototype.initialize.apply(this, arguments);
                var render = _.debounce(this.render, 0);
                this.model.searchJob.entry.content.on("change:isPreviewEnabled change:resultCount change:resultPreviewCount", render, this);
            },
            render: function() {
                var resultCount = this.model.searchJob.entry.content.get('isPreviewEnabled') ? this.model.searchJob.entry.content.get('resultPreviewCount') : this.model.searchJob.entry.content.get('resultCount');
                this.$el.html(i18n.format_decimal(resultCount) + i18n.ungettext(_(' result').t(), _(' results').t(), resultCount));
            }
        });
    }
);