define(['underscore', 'module', 'views/shared/WaitSpinner', 'splunk.util'],function(_, module, SpinnerView, splunkutil) {
    return SpinnerView.extend({
        className: 'pull-left',
        moduleId: module.id,
        initialize: function() {
           SpinnerView.prototype.initialize.apply(this, arguments);
           this.model.entry.content.on('change:dispatchState change:isDone change:isPaused', this.debouncedRender, this);
        },
        render: function() {
            var active = !(this.model.entry.content.get("isDone") || this.model.entry.content.get("isPaused") || this.model.isNew());
            
            if (this.active === active) {
                return this;
            }
            
            this.$el[active ? 'show' : 'hide']()[active ? 'addClass' : 'removeClass']('active');
            this[active ? 'start' : 'stop']();
            this.active = active;
            return this;
        }
    });
});
