define(
    [
        'module',
        'views/Base',
        'views/shared/jobstatus/buttons/ShareButton',
        'views/shared/jobstatus/buttons/ExportButton',
        'views/shared/jobstatus/buttons/PrintButton'
    ],
    function(module, Base, ShareButton, ExportButton, PrintButton) {
        /**
         * View Hierarchy:
         *
         * Share
         * Export
         * Print
         */
        return Base.extend({
            moduleId: module.id,
            className: 'pull-right export-print-group btn-group',
            initialize: function() {
                Base.prototype.initialize.apply(this, arguments);

                //Share
                this.children.shareButton = new ShareButton({
                    model: {
                        searchJob: this.model.searchJob,
                        application: this.model.application
                    }
                });

                //Export
                this.children.exportButton = new ExportButton({
                    model: {
                        searchJob: this.model.searchJob,
                        application: this.model.application,
                        report: this.model.report
                    }
                });

                //Print
                this.children.printButton = new PrintButton();
            },
            render: function() {
                this.$el.append(this.children.shareButton.render().el);
                this.$el.append(this.children.exportButton.render().el);
                this.$el.append(this.children.printButton.render().el);

                return this;
            }
        });
    }
);
