define(['underscore', 'module', 'views/Base'], function(_, module, BaseView) {
    return BaseView.extend({
        moduleId: module.id,
        className: 'cancel btn btn-small btn-square',
        tagName: 'a',
        attributes: {
            "href": "#"
        },
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        events: {
            'click': function(e) {
                e.preventDefault();
                this.model.destroy();
                this.model.clear();
            }
        },
        isActive: function() {
            return !this.model.isNew() && !this.model.entry.content.get('isDone');
        },
        render: function() {
            this.$el.html('<i class="icon-trash"></i><span class="hide-text">' + _("Cancel").t() + '</span>');
            return this;
        }
    });
});
