define(['jquery', 'underscore', 'module', 'views/Base'], function($, _, module, BaseView) {
    return BaseView.extend({
        moduleId: module.id,
        className: 'playpause btn btn-small btn-square',
        tagName: 'a',
        attributes: {
            "href": "#"
        },
        initialize: function(){
            BaseView.prototype.initialize.apply(this, arguments);
            this.model.entry.content.on('change', this.render, this);
        },
        events: {
            'click': function(e) {
                e.preventDefault();
                var action = $(e.currentTarget).data('mode'),
                    options = {
                        success: function() {
                            this.model.fetch();
                        }.bind(this)
                    };

                if(action === 'pause') {
                    this.model.pause(options);
                }
                else if(action === 'unpause') {
                    this.model.unpause(options);
                }
            }
        },
        isActive: function() {
            return (this.model.isRunning() || this.model.entry.content.get('isPaused'));
        },
        render: function() {
            if (this.model.entry.content.get('isPaused')) {
                this.$el.data('mode', 'unpause').html('<i class="icon-play"></i><span class="hide-text">' + _("Unpause").t() + '</span>');
            } else {
                this.$el.data('mode', 'pause').html('<i class="icon-pause"></i><span class="hide-text">' + _("Pause").t() + '</span>');
            }
            this.$el.show();
            return this;
        }
    });
});
