define(['underscore', 'module', 'views/Base'], function(_, module, BaseView) {
    return BaseView.extend({
        moduleId: module.id,
        className: 'reload btn btn-small btn-square',
        tagName: 'a',
        attributes: {
            "href": "#"
        },
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        events: {
            "click": function(e) {
                e.preventDefault();
                // just trigger a custom event on the job model and let upstream logic handle it
                this.model.trigger('reload');
            }
        },
        isActive: function() {
            // active only when the job is complete
            return this.model.entry.content.get('isDone');
        },
        render: function() {
            this.$el.html('<i class="icon-rotate-counter"></i><span class="hide-text">' + _('Reload').t() + '</span>');
            return this;
        }
    });
});
