define(['underscore','module', 'views/Base'], function(_, module, BaseView) {
    return BaseView.extend({
        moduleId: module.id,
        className: 'stop btn btn-small btn-square',
        tagName: 'a',
        attributes: {
            "href": "#"
        },
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
        },
        events: {
            "click": function(e) {
                e.preventDefault();
                if (this.model.isQueued() || this.model.isParsing()) {
                    this.model.destroy({
                        success: function() {
                            this.model.clear();
                        }.bind(this)
                    });
                } else {
                    this.model.finalize({
                        success: function() {
                            this.model.fetch();
                        }.bind(this)
                    });
                }
            }
        },
        isActive: function() {
            return !this.model.isNew() && !this.model.entry.content.get('isDone');
        },
        render: function() {
            this.$el.html('<i class="icon-stop"></i><span class="hide-text">' + _("Stop").t() + '</span>');
            return this;
        }
    });
});
