define(
    [        
        'underscore',
        'module',
        'views/Base',
        'util/splunkd_utils'
    ], 
    function(_, module, BaseView, splunkd_utils) {
        return BaseView.extend({
            moduleId: module.id,
            className: 'job_messages',
            tagName: 'ul',
            initialize: function(){
                BaseView.prototype.initialize.apply(this, arguments);
                
                this.model.searchJob.on('serverValidated', this.checkMessages, this);
            },
            checkMessages: function(isValid, model, messages) {
                var filteredMessages = splunkd_utils.filterMessagesByTypes(messages, [splunkd_utils.INFO, splunkd_utils.WARNING]);
                
                if (filteredMessages.length) {
                    this.showMessages(filteredMessages);
                } else {
                    this.$el.empty();
                }
            },
            showMessages: function(messages) {
                this.$el.empty();
                _.each(messages, function(message, index){
                    this.$el.append(
                        _.template(this.messagesTemplate, {
                            message: message
                        })
                    );
                }.bind(this));
            },
            render: function() {
                this.checkMessages();
                return this;
            },
            messagesTemplate: '\
                <li class="job_message"><%- message.text %></li>\
            '
        });
    }
);