// footer nav
define([
    'jquery',
    'underscore',
    'backbone',
    'module',
    'views/Base'
],
function(
    $,
    _,
    Backbone,
    module,
    BaseView
){
    return BaseView.extend({
        tagName: 'div',
        className: "view-time-range-picker-time-and-date-range-hours-minutes-seconds pull-left",
        moduleId: module.id,
        initialize: function() {
            BaseView.prototype.initialize.call(this, arguments);
            
            this.model.on("attributeValidated:second", function(isValid, key, error) {
                if (isValid) {
                    this.$("input").removeClass("error");
                } else {
                    this.$("input").addClass("error");
                }
            }, this);
            
            this.model.on("change", this.updateTime, this);
        },
        events: {
            'keyup input[type="text"]': function(){
                this.model.off("change", this.updateTime, this);
                this.model.setHoursMinSecFromStr(this.$('input').val(), {validate: true});
                this.model.on("change", this.updateTime, this);
            }
        },
        updateTime: function() {
            var time = this.model.time();
            this.$('input').val(time).removeClass("error");
        },
        render: function() {
            var time = this.model.time();
            
            var template = _.template(this.template, {
                time: time
            });
            this.$el.html(template);
            
            return this;
        },
        template: '\
            <input type="text" size="10" value="<%- time %>"/>\
            <span class="help-block"><%- _("HH:MM:SS.SSS").t() %></span>\
            '
    });
});
