define([
            "jquery",
            "underscore",
            "backbone",
             "module",
             "views/Base",
             "views/shared/controls/DateControl",
             "views/shared/timerangepicker/dialog/dateandtimerange/timeinput/HoursMinutesSeconds"
      ],
     function($, _, Backbone, module, BaseView, DateControl, HoursMinutesSeconds) {
        return BaseView.extend({
            tagName: 'table',
            className: 'form form-inline pull-left',
            moduleId: module.id,
            initialize: function() {
                BaseView.prototype.initialize.call(this, arguments);
            
                this.children.monthDayYear = new DateControl({
                    parentCid: this.cid,
                    model: this.model.dateTime,
                    className: 'control pull-left',
                    inputClassName: this.options.inputClassName || 'date',
                    validate: true
                });
            
                this.children.hoursMinutesSeconds = new HoursMinutesSeconds({
                    model: this.model.dateTime
                });
            },
            render: function() {
                if (!this.el.innerHTML) {
                    var template = _.template(this.template, {
                        _: _,
                        cid: this.cid,
                        label: this.options.label
                    });
                    this.$el.html(template);
                
                    this.$("td").last().append(this.children.monthDayYear.render().el);
                    this.$("td").last().append(this.children.hoursMinutesSeconds.render().el);
                } else {
                    this.children.monthDayYear.render();
                    this.children.hoursMinutesSeconds.render();
                }
                return this;
            },
            template: '\
                <tbody>\
                    <tr>\
                        <td>\
                            <label class="control-label" for="monthdayyear_<%- cid %>"><%- label %><%- _(":").t() %></label>\
                        </td>\
                        <td>\
                        </td>\
                    </tr>\
                </tbody>\
            '
        });
    }
);
