define(['underscore', 'module', 'views/Base', 'splunk.i18n'], function(_, module, BaseView, i18n) {
    return BaseView.extend({
        tagName: 'li',
        moduleId: module.id,
        initialize: function(){
            BaseView.prototype.initialize.apply(this, arguments);
            this.model.searchJob.entry.content.on('change:resultPreviewCount change:resultCount change:dispatchState', this.debouncedRender, this);
            this.model.report.entry.content.on('change:display.general.type', this.toggleActive, this);
        },        
        events: {
            'click a': function(e){
                this.model.report.entry.content.set('display.general.type', $(e.currentTarget).attr('data-type'));
                e.preventDefault();
            }
        },
        toggleActive: function() {
            (this.model.report.entry.content.get('display.general.type') == 'statistics') ? 
                this.$el.addClass('active') : 
                this.$el.removeClass('active');
        },
        render: function() {
            this.$el.html(this.compiledTemplate({
                _: _,
                searchJob: this.model.searchJob,
                i18n: i18n
            }));
            this.toggleActive();
            return this;
        },
        template:'\
            <a href="#" data-type="statistics">\
                <% if (searchJob.isNew() || !searchJob.entry.content.get("reportSearch")) { %>\
                    <%- _("Statistics").t() %>\
                <% } else { %>\
                    <%- _("Statistics").t() %> (<%= i18n.format_decimal(searchJob.resultCountSafe()) %>)\
                <% } %>\
            </a>\
        '
    });
});
