define(['underscore', 'module', 'views/Base'], function(_, module, BaseView) {
    return BaseView.extend({
        tagName: 'li',
        moduleId: module.id,
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.model.report.entry.content.on('change:display.general.type', this.toggleActive, this);
        },
        events: {
            'click a': function(e){
                this.model.report.entry.content.set('display.general.type', $(e.currentTarget).attr('data-type'));
                e.preventDefault();
            }
        },
        toggleActive: function() {
            (this.model.report.entry.content.get('display.general.type') == 'visualizations') ? 
                this.$el.addClass('active') : 
                this.$el.removeClass('active');
        },
        render: function() {
            this.$el.html(this.compiledTemplate({
                _: _
            }));
            this.toggleActive();
            return this;
        },
        template:'\
            <a href="#" data-type="visualizations">\
                <%- _("Visualization").t() %>\
            </a>\
        '
    });
});
