<%page args="element" />\
<%
options = dict()
if element.selected is not None:
    # Is either a preset name or an {earliestTime: x, latestTime: y} dict
    if isinstance(element.selected, str):
        options['preset'] = element.selected
    else:
        options['default'] = dict(
            earliest_time=element.selected['earliestTime'],
            latest_time=element.selected['latestTime']
        )
if element.token is None:
    earliest_token_name = 'earliest'
    latest_token_name = 'latest'
    form_earliest_token_name = 'earliest'
    form_latest_token_name = 'latest'
else:
    earliest_token_name = '%s.earliest' % element.token
    latest_token_name = '%s.latest' % element.token
    form_earliest_token_name = 'form.'+earliest_token_name
    form_latest_token_name = 'form.'+latest_token_name
%>\
new TimeRangeInput({
            "id": "${element.id}",
        % for k,v in options.items():
            ${k|json_decode}: ${json_decode(v)|n},
        % endfor
            "earliest_time": "$${form_earliest_token_name}$",
            "latest_time": "$${form_latest_token_name}$",
            "el": $('#${element.id}')
        }, {tokens: true}).render();


        ${element.id}.on("change", function(value, input, options) {
            if (!${element.id}.hasValue()) {
                defaultUpdate['${element.id}'] = true;
                ${element.id}.updateValueWithDefault();
                return;
            }

%if element.token is not None:
            var newValue = ${element.id}.val();
            defaultTokenModel.set({
                "${earliest_token_name}": newValue.earliest_time,
                "${latest_token_name}": newValue.latest_time
            });
            
%endif
        %if hasattr(element, 'searchWhenChanged') and element.searchWhenChanged:
            // Submit the token only if it wasn't from setting the default
            if (defaultUpdate['${element.id}']) {
                defaultUpdate['${element.id}'] = false;
            } else {
                submitTokens();
            }
        %endif
        });
        defaultUpdate['${element.id}'] = true;
        ${element.id}.trigger("change", ${element.id}.val(), ${element.id});